#version 120

varying vec4 color;
varying vec4 texcoord;
varying vec2 lmcoord;
varying vec3 normal;

uniform float frameTimeCounter;

void main() {
	
	texcoord = (gl_MultiTexCoord0);
	lmcoord = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
	
	vec4 position = gl_ModelViewMatrix * gl_Vertex;
	
	position.y += sin(frameTimeCounter)*0.01;
	position.z -= cos(frameTimeCounter)*0.005;

	gl_Position = gl_ProjectionMatrix * position;
	
	color = gl_Color;
	
	normal = normalize(gl_NormalMatrix * gl_Normal);
}