float edepth(sampler2D depth, vec2 coord) {
	return texture2D(depth,coord).r;
}

float sseo(float ao, sampler2D depth, vec3 fragpos){
	float total = 0.0;
	float d = edepth(depth,texcoord.xy);
	float dtresh = 1/(far-near)/200.0;	
	vec4 dc = vec4(d,d,d,d);
	vec4 sa = vec4(0.0);
	vec4 sb = vec4(0.0);
	
	float dist = pow(1.0/length(fragpos),0.2);
	float noise = 0.7+0.6*dither4x4(texcoord.xy)*dist;
	float pw = 20.0/1280.0*noise;
	float ph = pw*aspectRatio;
	
	for(int i = 0; i < 2; i++){
		sa.x = edepth(depth,texcoord.xy + vec2(-pw,-ph)*0.7*(1.0+i));
		sa.y = edepth(depth,texcoord.xy + vec2(pw,-ph)*0.7*(1.0+i));
		sa.z = edepth(depth,texcoord.xy + vec2(-pw,0.0)*(1.0+i));
		sa.w = edepth(depth,texcoord.xy + vec2(0.0,ph)*(1.0+i));
		
		sb.x = edepth(depth,texcoord.xy + vec2(pw,ph)*0.7*(1.0+i));
		sb.y = edepth(depth,texcoord.xy + vec2(-pw,ph)*0.7*(1.0+i));
		sb.z = edepth(depth,texcoord.xy + vec2(pw,0.0)*(1.0+i));
		sb.w = edepth(depth,texcoord.xy + vec2(0.0,-ph)*(1.0+i));
		
		vec4 dd = (2.0* dc - sa - sb) - dtresh;
		dd = vec4(step(dd.x,0.0),step(dd.y,0.0),step(dd.z,0.0),step(dd.w,0.0));
		float e = clamp(dot(dd,vec4(0.25)),0.0,1.0);
		total += e;
		dtresh = 1/(far-near)/(200.0+100*i);
	}
	total = mix(1.0,total*0.5,dist)*0.4+0.6;
	return ao*total;
}

vec3 convertScreenSpaceToWorldSpace(vec2 co, float depth){
vec4 fragposition = gbufferProjectionInverse * vec4(vec3(co, depth) * 2.0 - 1.0, 1.0);
fragposition /= fragposition.w;
return fragposition.xyz;
}

vec3 convertCameraSpaceToScreenSpace(vec3 cameraSpace){
vec4 clipSpace = gbufferProjection * vec4(cameraSpace, 1.0);
vec3 NDCSpace = clipSpace.xyz / clipSpace.w;
vec3 screenSpace = 0.5 * NDCSpace + 0.5;
return screenSpace;
}

float ssao(sampler2D depth, vec3 norm){
	float ao = 0.0;
	float pi = 22.0/7.0;
	float aopixeldepth = texture2D(depth,texcoord.xy).x;
	vec3 projpos = convertScreenSpaceToWorldSpace(texcoord.xy,aopixeldepth); 
	vec2 noiseAO = vec2(dither4x4(texcoord.xy),dither4x4(vec2(texcoord.x,-texcoord.y)))*2.0-1.0;
	
	float rprogress = 90.0;
	float sprogress = 1.0;
	ao = 0.0;
	float distval = 0.025;

	float aosize = 40.0/1280.0;
	float projrad = clamp(distance(convertCameraSpaceToScreenSpace(projpos + vec3(1)).xy,texcoord.xy),aosize*0.5,aosize);
	noiseAO = noiseAO*projrad*0.15;
	
	for (int i = 0; i < 4; i++) {
		for (int j = 0; j < 6; j++) {
			vec2 samplecoord = vec2(cos(rprogress*pi/180),sin(rprogress*pi/180))*(sprogress*projrad*vec2(1,aspectRatio)) + texcoord.xy + noiseAO;
			float sample = texture2D(depth,samplecoord).x;
			vec3 sprojpos = convertScreenSpaceToWorldSpace(samplecoord,sample);
			float angle = pow(min(1.0-dot(norm,normalize(sprojpos-projpos)),1.0),1.5);
			float dist = pow(min(abs(ld(sample)-ld(aopixeldepth)),distval)/distval,1.5);
			float temp = min(dist+angle,1.0);
			ao += temp;
			rprogress += 360/6;
		}
		sprogress = (1.0+i)/4;
		rprogress += 180/4;
	}

	ao /= 24;
	return ao;
}